<?php
// $Id: pg_account.admin.inc,v 1.4 2008/07/09 16:26:08 gor Exp $
/********************************************************************
 * Functions callback
 ********************************************************************/
function pg_account_complete (&$form_state,$t){
  global $user;
  if($user->uid != 1 or $user->uid != $t->uid){
   drupal_access_denied();
  }
  $form['amount'] = array(
    '#type'  => 'markup',
    '#value' => t('!currency !amount', array('!amount' => $t->amount,'!currency' => variable_get('pg_simplepay_symbol','$')))
  );
  $form['title'] = array(
    '#type'  => 'markup',
    '#value' => $t->title
  );
  $form['method'] = array(
    '#type'  => 'markup',
    '#value' => module_invoke($t->method, 'pgapi_gw','display name')
  );
  $b=pg_account_balance_load($t->uid);
  $form['balance'] = array(
    '#type'  => 'markup',
    '#value' => t('Your current balance is !currency !balance', array('!balance' => $b->balance ,'!currency' => variable_get('pg_simplepay_symbol','$')))
  );

  return $form;
}


function pg_account_payform($form_state,$t) {
  global $user;
  if($user->uid!=1 && $user->uid != $t->uid){
    drupal_access_denied();
  }
  $balance=pg_account_balance_load($user->uid);
  if($balance->balance < $t->amount * variable_get('pg_pgaccount_rate','1.00')){
    drupal_set_message(t('Please, fill up you account'),'error');
    return '';
  }
  $form['txnid'] = array(
    '#type' => 'value',
    '#value' => $t->txnid,
  );

  $form['title'] = array(
    '#type' => 'markup',
    '#value' => $t->title
  );

  $form['price'] = array(
    '#title' => t('Price'),
    '#type' => 'markup',
    '#value' => t('<div><b>Price:</b> %currency_symbol %price</div>', array('%price'=> $t->amount , '%currency_symbol' => variable_get('pg_simplepay_symbol','$') ) ),
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Place your order'),
  );
  return $form;
}
function pg_account_payform_submit($form, &$form_state){
  global $user;
  $txnid=$form_state['values']['txnid'];
  $t=pgapi_transaction_load($txnid);
  $balance=pg_account_balance_load($user->uid);
  $balance->balance=$balance->balance - $t->amount * variable_get('pg_pgaccount_rate','1.00');
  pg_account_balance_save($user->uid,$balance->balance);
  $t->status = pgapi_get_status_id('completed');
  pgapi_transaction_save($t);
  if($t->type == "pg_account")
    drupal_set_message(t('Your balance has been updated.'));
  $goto = pgapi_GetBackUrl($t,'success');
  $form_state['redirect'] = $goto;
}

function pgaccount_settings(){
  $form['pg_pgaccount_rate'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Rate to site currency'),
    '#default_value' => variable_get('pg_pgaccount_rate','1.00'),
    '#description'   => t("Please enter Account Balance rate according to site currency."),
  );
  $form['pg_pgaccount_symbol'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Symbol'),
    '#default_value' => variable_get('pg_pgaccount_symbol','$'),
    '#description'   => t("Please enter symbol of the Account Balance currency."),
  );

  $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => t('Update status of money out settings'),
  );

  return $form;
}


function pgaccount_settings_validate($form, &$form_state) {
  if($form_state['values']['pg_pgaccount_rate']<=0){
    form_set_error('pg_pgaccount_rate', t('%rate must be more 0.', array('%rate' => $form_state['values']['pg_pgaccount_rate'])));
  }
}

function pgaccount_settings_submit($form, &$form_state){

  if(isset($form_state['values']['pg_pgaccount_rate']))
    variable_set('pg_pgaccount_rate',$form_state['values']['pg_pgaccount_rate']);
  if(isset($form_state['values']['pg_pgaccount_symbol']))
    variable_set('pg_pgaccount_symbol',$form_state['values']['pg_pgaccount_symbol']);
}

/*
function pgaccount_settings(){
  $form['#tree'] = TRUE;
  $pgaccount_moneyout=variable_get('pgaccount_moneyout',array());
  foreach (module_implements('pgaccount_moneyout') as $module) {
    if ($module_name= module_invoke($module, 'pgaccount_moneyout','display name')) {
      $form[$module]['modulename']=array ('#value' => $module_name);
      if($pgaccount_moneyout[$module]){
        $default='checked';
      }
      $form[$module]['checkbox']=array(
        '#type' => 'checkbox',
        '#default_value' => $default
      );
    }
  }


  $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => t('Update status of money out settings'),
  );

  return $form;
}


function pgaccount_settings_submit($form, &$form_state){
  $pgapi_gw=array();
  foreach($form_state['values'] as $key => $val) {
    if($val['checkbox']==1){
      $pgaccount_moneyout[$key]=true;
    }
  }
  variable_set('pgaccount_moneyout',$pgaccount_moneyout);
  drupal_set_message(t('Status of money out has been updated.'));
}

*/
function pgaccount_moneyout_setting(){
}

function pgaccount_balance(){
  global $user;
  $balance=pg_account_balance_load($user->uid);
  $form['balance'] = array(
   '#value' => t('Your current balance is: %currency %balance ',array('%balance' => $balance->balance ? $balance->balance : 0, '%currency' => variable_get('pg_pgaccount_symbol','$'))),
  );
  $form['amount'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Amount'),
    '#description'   => t("Please enter amount to fill up balance."),
  );
  $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => t('Submit'),
  );

  return $form;
}

function pgaccount_balance_submit($form, &$form_state){
  global $user;
  $t = (object)(NULL);
  $t->amount=$form_state['values']['amount'] / variable_get('pg_pgaccount_rate','1.00');
  $t->type='pg_account';
  $t->uid=$user->uid;
  $t->title=t('Filling up of balance');
  $t = pgapi_transaction_save($t);
  $form_state['redirect'] = 'payment/'. $t->txnid;
}

/********************************************************************
 * Other Functions
 ********************************************************************/
