<?php


class pg_simplepay_hfield_access extends views_handler_field_boolean {

  function construct() {
    parent::construct();
    $this->additional_fields['nid'] = array('table' => 'node', 'field' => 'nid');
    $this->additional_fields['vid'] = array('table' => 'node', 'field' => 'vid');
    $this->additional_fields['type'] = array('table' => 'node', 'field' => 'type');
  }

  function render($values) {
  	$is_free = $values->{$this->field_alias};
  	$node_type = $values->{$this->aliases['type']};
    $value = $is_free || pg_simplepay_is_grant_type($node_type) || pg_simplepay_is_paid($values->{$this->aliases['nid']}, $values->{$this->aliases['vid']});

    if (!empty($this->options['not'])) {
      $value = !$value;
    }
    switch ($this->options['type']) {
      case 'yes-no':
      default:
        return $value ? t('Yes') : t('No');
      case 'true-false':
        return $value ? t('True') : t('False');
      case 'on-off':
        return $value ? t('On') : t('Off');
    }
  }

}

