<?php


function pg_simplepay_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'pg_simplepay') . '/includes/views/handlers',
    ),
    'handlers' => array(

      // field handlers
      'pg_simplepay_hfield_access' => array(
        'parent' => 'views_handler_field_boolean',
      ),
      'pg_simplepay_hfield_user_paid' => array(
        'parent' => 'views_handler_field_boolean',
      ),
      'pg_simplepay_hfield_user_paid_time' => array(
        'parent' => 'views_handler_field_date',
      ),
      'pg_simplepay_hfield_price' => array(
        'parent' => 'views_handler_field',
      ),

      // filter handlers
      'pg_simplepay_hfilter_user_paid' => array(
        'parent' => 'views_handler_filter',
       ),

    ),
  );
}

function pg_simplepay_views_data() {

  $data['pg_simplepay_price']['table']['group']  = t('Purchase');
  $data['pg_simplepay_price']['table']['join'] = array(
    'node' => array(
       'left_field' => 'vid',
       'field' => 'vid',
  	)
  );

  $data['pg_simplepay_price']['pg_simplepay_access'] = array(
    'real field' => 'free',
  	'title' => t('Access'),
    'field' => array('handler' => 'pg_simplepay_hfield_access'),
  );
  $data['pg_simplepay_price']['pg_simplepay_free'] = array(
    'real field' => 'free',
  	'title' => t('Free'),
    'field' => array('handler' => 'views_handler_field_boolean'),
    'filter' => array('handler' => 'views_handler_filter_boolean_operator', 'title' => t('Free'), ),
  );
  $data['pg_simplepay_price']['pg_simplepay_price'] = array(
    'real field' => 'price',
  	'title' => t('Price'),
    'field' => array('handler' => 'pg_simplepay_hfield_price'),
    'filter' => array('handler' => 'views_handler_filter_numeric' ),
  );

  $data['pg_simplepay_payment_user']['table']['group']  = t('Purchase');
  $data['pg_simplepay_payment_user']['table']['join'] = array(
    'node' => array(
      'table' => 'pg_simplepay_payment',
      'left_field' => 'vid',
      'field' => 'vid',
      'extra' => array(
        array('field' => 'uid', 'value' => '***CURRENT_USER***', 'numeric' => TRUE),
      ),
    ),
  );

  $data['pg_simplepay_payment_user']['txnid'] = array(
    'title' => t('User paid'),
    'field' => array(
      'handler' => 'pg_simplepay_hfield_user_paid',
    ),
    'filter' => array(
      'handler' => 'pg_simplepay_hfilter_user_paid',
    ),
  );

  $data['pg_simplepay_payment_user']['pg_simplepay_paid_time'] = array(
    'real field' => 'created',
    'title' => t('User paid time'),
    'field' => array(
      'handler' => 'pg_simplepay_hfield_user_paid_time',
    ),
  );

  return $data;
}

