<?php
// $Id: pg_simplepay.admin.inc,v 1.2 2008/07/08 16:34:03 gor Exp $

/********************************************************************
 * Functions callback
 ********************************************************************/

function pg_simplepay_common(){
  $form['pg_simplepay_show'] = array (
    '#type'          => 'select',
    '#title'         => t('Price fieldset'),
    '#default_value' => variable_get('pg_simplepay_show',TRUE),
    '#options'       => array(
            TRUE  => t('Show'),
            FALSE => t('Hide'),
    ),
    '#description'   => t('Show price fieldset'),
  );
  $form['pg_simplepay_link_show'] = array (
    '#type'          => 'select',
    '#title'         => t('Purchase link'),
    '#default_value' => variable_get('pg_simplepay_link_show',TRUE),
    '#options'       => array(
            TRUE  => t('Show'),
            FALSE => t('Hide'),
    ),
    '#description'   => t('Show purchase link'),
  );
  $form['pg_simplepay_position'] = array (
    '#type'          => 'select',
    '#title'         => t('Symbol position'),
    '#default_value' => variable_get('pg_simplepay_position',TRUE),
    '#options'       => array(
            TRUE  => t('Left'),
            FALSE => t('Right'),
    ),
    '#description'   => t('This option places the currency symbol of the left or right side of the price.'),
  );
  $form['pg_simplepay_symbol'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Symbol'),
    '#default_value' => variable_get('pg_simplepay_symbol','$'),
    '#description'   => t("Please enter symbol of the simplepay currency."),
  );
  $form['pg_simplepay_thousands'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Thousands separator'),
    '#default_value' => variable_get('pg_simplepay_thousands', ','),
    '#size'          => 3,
    '#maxlength'     => 5,
    '#description'   => t('Enter the sign for the thousands separator.')
   );
   $form['pg_simplepay_decimal'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Decimal separator'),
    '#default_value' => variable_get('pg_simplepay_decimal', '.'),
    '#size'          => 3,
    '#maxlength'     => 5,
    '#description'   => t('Enter the sign to seperate real numbers from floating numbers.')
   );
  $form['pg_simplepay_decimal_places'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Number of places after the decimal separator'),
    '#default_value' => variable_get('pg_simplepay_decimal_places', 2),
    '#size'          => 3,
    '#maxlength'     => 5,
    '#description'   => t('How many slots are needed after the decimal?')
   );


  return system_settings_form($form);
}

function pg_simplepay_prepay ($node){
  global $user;
  $t = (object)(NULL);
  $t->amount=$node->pg_simplepay_price;
  $t->type='pg_simplepay';
  $t->uid=$user->uid;
  $t->title=t('You have been ordered title ', array('title' => $node->title));
  $t->extra=array(
    'nid' => $node->nid,
    'vid' => $node->vid,
  );
  $t = pgapi_transaction_save($t);
  $payment_url=  url('payment/'. $t->txnid,array('absolute' => TRUE));
  drupal_goto($payment_url);
  return '';
}

function pg_simplepay_complete (&$form_state,$t){
  $form['amount'] = array(
    '#type'  => 'markup',
    '#value' => t('!currency !amount', array('!amount' => $t->amount,'!currency' => variable_get('pg_simplepay_symbol','$')))
  );
  $form['title'] = array(
    '#type'  => 'markup',
    '#value' => $t->title
  );
  $form['method'] = array(
    '#type'  => 'markup',
    '#value' => module_invoke($t->method, 'pgapi_gw','display name')
  );
  return $form;
}

/********************************************************************
 * Other Functions
 ********************************************************************/
