<?php
/********************************************************************
 * Functions callback
 ********************************************************************/
function pgapi_pgdata (){
  $item = menu_get_item('admin/pgdata');
  $content = system_admin_menu_block($item);
  $output = theme('admin_block_content', $content);
  return $output;
}


function pgapi_payment (&$form_state,$t){
  global $user;
  if($user->uid!=1 && $user->uid != $t->uid){
    drupal_access_denied();
  }
  $pgapi_gw=pgapi_getActivePG();
  foreach ($pgapi_gw as $module => $checked) {
      if($checked){
        if ($module_data= module_invoke($module, 'pgapi_gw','payment gateway info',$t->amount,$t)) {
          $form[$module]['modulename']=array (
            '#value' => $module_data['name'],
          );
          $options[$module]='';
          if(empty($default)) 
             $default=$module;
          $form[$module]['price']=array (
          '#value' => theme('pgapi_gateway_price',$module_data['price'],$t->type),
          );
        }
      }
      $form['method']=array(
        '#type'    => 'radios',
        '#options' => $options,
        '#default_value' => $t->method ? $t->method : $default,
      );
  }

  $form['txnid']=array(
    '#type'  => 'value',
    '#value' => $t->txnid,
  );
  $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => t('Process purchase'),
  );
  $form['cancel'] = array(
    '#type'  => 'submit',
    '#value' => t('Cancel purchase'),
  );
  return $form;
}


function pgapi_payment_submit($form, &$form_state) {
  if($form_state['values']['op'] == $form_state['values']['submit'] && !empty($form_state['values']['method'])){
    $module=$form_state['values']['method'];
    $txnid=$form_state['values']['txnid'];
    $t=pgapi_transaction_load($txnid);
    $t->method=$module;
    pgapi_transaction_save($t);
    $goto = module_invoke($module, 'pgapi_gw','payment page',$txnid);
  }else {
    $site_frontpage=variable_get('site_frontpage','/node');
    $goto=url($site_frontpage ,array('absolute' => TRUE));
  }
  $form_state['redirect'] = $goto;
}


function pgapi_common() {
  $form['#tree'] = TRUE;
  $pgapi_gw=variable_get('pgapi_gw',array());
  foreach (module_implements('pgapi_gw') as $module) {
    if ($module_name= module_invoke($module, 'pgapi_gw','display name')) {
      $form[$module]['modulename']=array ('#value' => $module_name);
      $default='';
      if($pgapi_gw[$module]){
        $default='checked';
      }
      $form[$module]['checkbox']=array(
        '#type' => 'checkbox',
        '#default_value' => $default
      );
    }
  }


  $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => t('Update status of payment gateways'),
  );

  return $form;
}

function pgapi_common_submit($form, &$form_state){
  $pgapi_gw=array();
  foreach($form_state['values'] as $key => $val) {
    if($val['checkbox']==1){
      $pgapi_gw[$key]=true;
    }
  }
  variable_set('pgapi_gw',$pgapi_gw);
  drupal_set_message(t('Status of payment gateway has been updated.'));
}



/********************************************************************
 * Other Functions
 ********************************************************************/
